Name: fatrat
Version: 1.1.3
Release: 2%{?dist}
Summary: Feature-rich download manager
Group: Applications/Internet
License: GPLv2+
URL: http://fatrat.dolezel.info/
Source0: http://www.dolezel.info/download/data/fatrat/fatrat-%{version}.tar.gz
Source1: http://www.dolezel.info/download/data/fatrat-czshare/fatrat-czshare-%{version}.tar.gz
Source2: http://www.dolezel.info/download/data/fatrat-opensubtitles/fatrat-opensubtitles-%{version}.tar.gz

Patch0: fatrat-plugins-path.patch
Patch100: fatrat-czshare-libdir.patch
Patch200: fatrat-opensubtitles-libdir.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cmake, qt4-devel >= 4.4
BuildRequires: libcurl-devel >= 7.18.2
BuildRequires: rb_libtorrent-devel => 0.14.5, asio-devel, qt-webkit-devel
BuildRequires: gloox-devel >= 0.9
BuildRequires: desktop-file-utils

%description
FatRat is download manager written in C++ and build on top of the Qt4 library.
It is rich in features and is continuously extended. Main characteristics:

- HTTP(S)/FTP downloads
- FTP uploads
- RSS feed support + special functions for TV shows and podcasts
- BitTorrent support (including torrent creating, DHT, UPnP, encryption etc.)
- Torrent search
- Support for SOCKS5 and HTTP proxies
- RapidShare.com FREE downloads
- RapidShare.com uploads
- RapidShare.com link verification and folder extraction
- RapidSafe link decoding
- MD4/MD5/SHA1 hash computing
- Remote control via Jabber
- Remote control via a web interface
- Subtitle search
- Scheduler
- Clipboard monitor

%package devel
Summary: Development libraries for fatrat
Group: Development/Libraries
Requires: fatrat = %{version}-%{release}

%description devel
FatRat is download manager written in C++ and build on top of the Qt4 library.
It is rich in features and is continuously extended.

This package contains header files needed for development of FatRat plugins.

%package czshare
Summary: FatRat plugin enabling CZShare.com downloads and uploads
Group: Applications/Internet
Requires: fatrat = %{version}-%{release}

%description czshare
FatRat is download manager written in C++ and build on top of the Qt4 library.
It is rich in features and is continuously extended.

This package contains plugin for downloading and uploading to CZshare.com.

%package opensubtitles
Summary: FatRat plugin enabling OpenSubtitles.org integration
Group: Applications/Internet
Requires: fatrat = %{version}-%{release}

%description opensubtitles
FatRat is download manager written in C++ and build on top of the Qt4 library.
It is rich in features and is continuously extended.

This package contains plugin for integration with OpenSubtitles.org (easy
subtitle searching).

%prep

# setup include dir for plugins compilation
mkdir include
ln -s ../fatrat-%{version}/src include/fatrat

# unpack all archives
%setup -q -b 1 -b 2

# patches for main application
%patch0 -p1 -b plugins-path

# patches for plugins
cd ../fatrat-czshare-%{version}
%patch100 -p1 -b libdir

cd ../fatrat-opensubtitles-%{version}
%patch200 -p1 -b opensubtitles

%build

# build main application

%{cmake} . \
	-DWITH_EVERYTHING=ON \
	-DCMAKE_EXE_LINKER_FLAGS="-Wl,-lpthread,-ldl,-lboost_system-mt,-lboost_filesystem-mt"

make %{?_smp_mflags}

# build plugins

for plugin in czshare opensubtitles; do
	cd %{_builddir}/fatrat-${plugin}-%{version}
	%{cmake} . -DFATRAT_INCLUDE_DIR=%{_builddir}/include
	make %{?_smp_mflags}
done

%install
rm -rf %{buildroot}

# install main application
make install DESTDIR=%{buildroot}

# update desktop file
sed -i '/^Categories=/s/Application;//g;/^Icon=/s/\.png$//' %{buildroot}/%{_datadir}/applications/fatrat.desktop
desktop-file-validate %{buildroot}/%{_datadir}/applications/fatrat.desktop

# install plugins
for plugin in czshare opensubtitles; do
	cd %{_builddir}/fatrat-${plugin}-%{version}
	make install DESTDIR=%{buildroot}
done

# documentation will be installed by doc macro
rm -rf %{buildroot}/%{_docdir}

# fatrat requires documentation in it's datadir
for file in AUTHORS INSTALL LICENSE README TRANSLATIONS; do
	rm -f %{buildroot}/%{_datadir}/fatrat/${file}
	[ $file == INSTALL ] && continue
	ln -s %{_docdir}/fatrat-%{version}/${file} %{buildroot}/%{_datadir}/fatrat/${file}
done

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc AUTHORS LICENSE README TRANSLATIONS
%{_bindir}/fatrat
%{_datadir}/fatrat
%{_mandir}/man1/*
%{_datadir}/applications/fatrat.desktop
%{_datadir}/pixmaps/fatrat.png

%files devel
%defattr(-,root,root,-)
%{_includedir}/fatrat

%files czshare
%defattr(-,root,root,-)
%doc ../fatrat-czshare-%{version}/data/TRANSLATIONS
%{_libdir}/fatrat/plugins/libfatrat-czshare.so

%files opensubtitles
%defattr(-,root,root,-)
%doc ../fatrat-opensubtitles-%{version}/data/TRANSLATIONS
%{_libdir}/fatrat/plugins/libfatrat-opensubtitles.so

%changelog
* Wed Sep 29 2010 Jan Vcelak <jvcelak@redhat.com> 1.1.3-2
- update czshare plugin

* Mon Sep 27 2010 Jan Vcelak <jvcelak@redhat.com> 1.1.3-1
- update to latest upstream version

* Wed Sep 08 2010 Jan Vcelak <jvcelak@redhat.com> 1.1.2-1
- initial release
